// -*-c++-*-

/******************************************************
 * @COPYRIGHT:Jun Masaki @ iesl,ies,sit 2009 
 ******************************************************/

////////////////////////////////////////////////////////

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "abstract_pg_method.h"

#include <stdexcept>

/*-------------------------------------------------------------------*/

///////////////////////////////////////////////////////////////////////
//
bool
Abstract_PGMethod::setDefaultSettings(void)
{
  std::vector<Learning_Item>::iterator 
    it = M_settingItems.begin();
  std::vector<Learning_Item>::const_iterator 
    end = M_settingItems.end();
  for(;it != end;++it){
    it->setParam(false);
  }
  return true;
}

///////////////////////////////////////////////////////////////////////
//
Learning_Item *
Abstract_PGMethod::getSettingItem( const int item_num )
{
  if(item_num < 0 || (int)M_settingItems.size() <= item_num)
    return NULL;

  try{
    return & M_settingItems.at(item_num);
  }catch(std::out_of_range & ex){
    std::cout << ex.what() << std::endl;
    return NULL;
  }
  return NULL;
}

///////////////////////////////////////////////////////////////////////
//
Learning_Item *
Abstract_PGMethod::getLearningDataItem( const int item_num )
{
  if(item_num < 0 || (int)M_dataItems.size() <= item_num)
    return NULL;

  try{
    return & M_dataItems.at(item_num);
  }catch(std::out_of_range & ex){
    std::cout << ex.what() << std::endl;
    return NULL;
  }
  return NULL;
}

///////////////////////////////////////////////////////////////////////
// class Learning_DataItem's methods is following.
///////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////
//
bool
Learning_Item::setParam( const double param )
{
  M_param_double = param;
  M_param_bool = false;
  M_param_string = "";
  M_param_setted_flag = true;
  M_no_bool_param_flag = true;
  return true;
}

///////////////////////////////////////////////////////////////////////
//
bool
Learning_Item::setParam( const bool param )
{
  M_param_bool = param;
  M_param_double = 0.0;
  M_param_string = "";
  M_param_setted_flag = true;
  M_no_bool_param_flag = false;
  return true;
}

///////////////////////////////////////////////////////////////////////
//
bool
Learning_Item::setParam( const std::string & param )
{
  M_param_string = param;
  M_param_double = 0.0;
  M_param_bool = false;
  M_param_setted_flag = true;
  M_no_bool_param_flag = true;
  return true;
}
