// -*-c++-*-

/********************************************************
 * @COPYRIGHT:Jun Masaki @iesl,ies,sit 2009 
 ********************************************************/

//////////////////////////////////////////////////////////

#ifndef LEARNING_DRIVER_H
#define LEARNING_DRIVER_H

#include "abstract_pg_method.h"

#include <vector>

class Learning_Driver {
  
private:

  /*****************************************************
   * 学習方策への参照
   *****************************************************/
  Abstract_PGMethod & method_ref;

  ///////////////////////////////////////////////////////

private:

  /*****************************************************
   *
   *****************************************************/
  bool initMethod( rcsc::PlayerAgent * agent );

  /*****************************************************
   *
   *****************************************************/
  bool readSettingFile();
  
  /*****************************************************
   *
   *****************************************************/
  bool readLearningDataFile();

  /*****************************************************
   *
   *****************************************************/
  bool makeNewLearningDataFile();

  /*****************************************************
   *
   *****************************************************/
  bool writeLearningDataFile();

  /*****************************************************
   *
   *****************************************************/
  int doBoltzmannSelection( rcsc::PlayerAgent * agent );

  /*****************************************************
   *
   *****************************************************/
  double calcEnergy( int action , rcsc::PlayerAgent * agent );

public:

  /*****************************************************
   * @PARAM:学習するPGMethodへの参照
   *****************************************************/
  Learning_Driver( Abstract_PGMethod & method ):method_ref(method){}

  /*****************************************************
   * @RETURN:If it executed , true.
   *****************************************************/
  bool execute( rcsc::PlayerAgent * agent );

  /*****************************************************
   * @RETURN:If the PGMethod is initialized 
   *         or endEpisode() returns ture , true.
   *****************************************************/
  bool prepare( rcsc::PlayerAgent * agent );

  /*****************************************************
   * @RETURN:If the episode is end , true. 
   *****************************************************/
  bool isEpisodeEnd( rcsc::PlayerAgent * agent );

  /*****************************************************
   * @RETURN:If the process to close the episode 
   *         is executed , true. 
   *****************************************************/
  bool endTheEpisode( rcsc::PlayerAgent * agent );

};

#endif
