
/////////////////////////////////////////////////////////////////////

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "utility_count_kickable_cycle.h"

#include <rcsc/game_time.h>

/*-------------------------------------------------------------------*/
/*!

*/

bool
Utility_CountKickableCycle::prepare( rcsc::PlayerAgent * agent ){
  static int S_current_cycle = -1;

  if(S_current_cycle == agent->world().time().cycle())
    return false;

  if(agent->world().self().isKickable()
     && M_last_kickableSelf_point.dist(agent->world().ball().pos()) < 3.5
     && agent->world().time().cycle() - M_prev_kickableSelf_cycle <= 7){
    M_prev_kickableSelf_cycle = agent->world().time().cycle();
  }else{
    M_start_kickableSelf_cycle = agent->world().time().cycle();
    M_prev_kickableSelf_cycle = agent->world().time().cycle();
    M_last_kickableSelf_point = agent->world().ball().pos();
  }

  if(M_last_self_point.dist(agent->world().self().pos()) < 3.5
     && agent->world().time().cycle() - M_prev_self_cycle <=7){
    M_prev_self_cycle = agent->world().time().cycle();
  }else{
    M_start_self_cycle = agent->world().time().cycle();
    M_prev_self_cycle = agent->world().time().cycle();
    M_last_self_point = agent->world().self().pos();
  }

  if(agent->world().existKickableTeammate()
     && M_last_kickableTeammate_point.dist(agent->world().ball().pos()) < 3.5
     && agent->world().time().cycle() - M_prev_kickableTeammate_cycle <= 7){
    M_prev_kickableTeammate_cycle = agent->world().time().cycle();
  }else{
    M_start_kickableTeammate_cycle = agent->world().time().cycle();
    M_prev_kickableTeammate_cycle = agent->world().time().cycle();
    M_last_kickableTeammate_point = agent->world().ball().pos();
  }

  if(agent->world().existKickableOpponent()
     && M_last_kickableOpponent_point.dist(agent->world().ball().pos()) < 3.5
     && agent->world().time().cycle() - M_prev_kickableOpponent_cycle <= 7){
    M_prev_kickableOpponent_cycle = agent->world().time().cycle();
  }else{
    M_start_kickableOpponent_cycle = agent->world().time().cycle();
    M_prev_kickableOpponent_cycle = agent->world().time().cycle();
    M_last_kickableOpponent_point = agent->world().ball().pos();
  }
  S_current_cycle = agent->world().time().cycle();
  return true;
}

