// -*-c++-*-

/////////////////////////////////////////////////////////////////////

#ifndef UTILITY_COUNT_KICKABLE_CYCLE_H
#define UTILITY_COUNT_KICKABLE_CYCLE_H

#include <rcsc/player/player_agent.h>
#include <rcsc/geom/vector_2d.h>

class Utility_CountKickableCycle {
private:

  int M_start_kickableSelf_cycle;
  int M_prev_kickableSelf_cycle;
  rcsc::Vector2D M_last_kickableSelf_point;
  int M_start_self_cycle;
  int M_prev_self_cycle;
  rcsc::Vector2D M_last_self_point;
  int M_start_kickableTeammate_cycle;
  int M_prev_kickableTeammate_cycle;
  rcsc::Vector2D M_last_kickableTeammate_point;
  int M_start_kickableOpponent_cycle;
  int M_prev_kickableOpponent_cycle;
  rcsc::Vector2D M_last_kickableOpponent_point;

  ////////////////////////////////////////////////////////////////////////

private:

  Utility_CountKickableCycle(void){
    M_start_kickableSelf_cycle = -1;
    M_prev_kickableSelf_cycle = -1;
    M_last_kickableSelf_point = rcsc::Vector2D(0.0,0.0);
    M_start_self_cycle = -1;
    M_prev_self_cycle = -1;
    M_last_self_point = rcsc::Vector2D(0.0,0.0);
    M_start_kickableTeammate_cycle = -1;
    M_prev_kickableTeammate_cycle = -1;
    M_last_kickableTeammate_point = rcsc::Vector2D(0.0,0.0);
    M_start_kickableOpponent_cycle = -1;
    M_prev_kickableOpponent_cycle = -1;
    M_last_kickableOpponent_point = rcsc::Vector2D(0.0,0.0);
  }
  Utility_CountKickableCycle( const Utility_CountKickableCycle & copy_constructor ){}
  Utility_CountKickableCycle & operator=( const Utility_CountKickableCycle & copy_operator ){}

public:
  
  static Utility_CountKickableCycle & getInstance(void){
    static Utility_CountKickableCycle singleton;
    return singleton;
  }

  bool prepare( rcsc::PlayerAgent * agent );

  int countKickableSelfAtSamePoint( rcsc::PlayerAgent * agent ){
    return agent->world().time().cycle() - M_start_kickableSelf_cycle;
  }

  int countSelfAtSamePoint( rcsc::PlayerAgent * agent ){
    return agent->world().time().cycle() - M_start_self_cycle;
  }

  int countKickableTeammateAtSamePoint( rcsc::PlayerAgent * agent ){
    return agent->world().time().cycle() - M_start_kickableTeammate_cycle;
  }

  int countKickableOpponentAtSamePoint( rcsc::PlayerAgent * agent ){
    return agent->world().time().cycle() - M_start_kickableOpponent_cycle;
  }

};

#endif
